searchNodes=[{"doc":"Microbox QWIT is a library for building workflows out of queued worker jobs, all of which can be run in transactions. When errors happen, the entire workflow gets rewound, exactly like a failed database transaction.Built originally with support only for Oban, the intent is to support other queued worker libraries in the future, so you can drop QWIT in with whatever queue engine your project needs and get all the same benefits.Don't need a full queue engine? Check out recipe instead!","ref":"QWIT.html","title":"QWIT","type":"module"},{"doc":"","ref":"QWIT.html#t:result/0","title":"QWIT.result/0","type":"type"},{"doc":"","ref":"QWIT.Flow.html","title":"QWIT.Flow","type":"behaviour"},{"doc":"","ref":"QWIT.Flow.html#c:build_flow/0","title":"QWIT.Flow.build_flow/0","type":"callback"},{"doc":"","ref":"QWIT.Flow.html#t:reaction/0","title":"QWIT.Flow.reaction/0","type":"type"},{"doc":"","ref":"QWIT.Oban.Flow.html","title":"QWIT.Oban.Flow","type":"behaviour"},{"doc":"","ref":"QWIT.Oban.Flow.html#c:start_flow/2","title":"QWIT.Oban.Flow.start_flow/2","type":"callback"},{"doc":"","ref":"QWIT.Oban.Step.html","title":"QWIT.Oban.Step","type":"behaviour"},{"doc":"","ref":"QWIT.Oban.Step.html#c:start_step/2","title":"QWIT.Oban.Step.start_step/2","type":"callback"},{"doc":"","ref":"QWIT.Step.html","title":"QWIT.Step","type":"behaviour"},{"doc":"","ref":"QWIT.Step.html#c:step_back/1","title":"QWIT.Step.step_back/1","type":"callback"},{"doc":"","ref":"QWIT.Step.html#c:step_forward/1","title":"QWIT.Step.step_forward/1","type":"callback"},{"doc":"","ref":"QWIT.Storage.html","title":"QWIT.Storage","type":"module"},{"doc":"","ref":"QWIT.Storage.html#delete/1","title":"QWIT.Storage.delete/1","type":"function"},{"doc":"","ref":"QWIT.Storage.html#get/2","title":"QWIT.Storage.get/2","type":"function"},{"doc":"","ref":"QWIT.Storage.html#put/2","title":"QWIT.Storage.put/2","type":"function"},{"doc":"","ref":"QWIT.Storage.html#start_link/0","title":"QWIT.Storage.start_link/0","type":"function"},{"doc":"Queued Workflows In Transactions Microbox QWIT is a library for building workflows out of queued worker jobs, and running them as transactions. When errors happen, the entire workflow gets rewound, exactly like a failed database transaction.Built originally with support only for Oban, the intent is to support other queued worker libraries in the future, so you can drop QWIT in with whatever queue engine your project needs and get all the same benefits.Don't need a full queue engine? Check out recipe instead!","ref":"readme.html","title":"Queued Workflows In Transactions","type":"extras"},{"doc":"Microbox Core performs tasks that need to be reversible in case of failures. Since this portion of the project is so reusable elsewhere, it made sense to extract it into its own package. While Core uses Oban to improve scalability, it makes sense to support as many queue engines as possible for maximum flexibility, so that's how we approach the architecture.","ref":"readme.html#why","title":"Queued Workflows In Transactions - Why?","type":"extras"},{"doc":"Add QWIT to your mix.exs with your other deps:{:qwit, &quot;~&gt; 0.1.0&quot;},Then, as usual, mix deps.get and you'll be set! Nothing to configure, here.","ref":"readme.html#installation","title":"Queued Workflows In Transactions - Installation","type":"extras"},{"doc":"QWIT provides a common interface to all supported queue engines. That means all you have to do is swap out your engine, update your modules, and everything else works as before. You can even use multiple engines at once, since the appropriate engine is passed as a use option.Workflows are provided by two module types - Flows and Steps. Flows dictate which steps are run in which order.defmodule MyApp.Work.Flows.Example do use QWIT.Flow @impl QWIT.Flow def build_flow do step MyApp.Work.Steps.Example, %{arg1: &quot;value1&quot;} step MyApp.Work.Steps.Example end endSteps do the actual work, with the return values of each serving as additional arguments to the next.defmodule MyApp.Work.Steps.Example use QWIT.Step import Logger @impl QWIT.Step def step_forward(%{arg1: arg1}) do Logger.info(&quot;Got first arg: \#{arg1}&quot;) {:ok, %{arg2: &quot;value2&quot;}} # pass arg2 to following steps in flow end def step_forward(%{arg2: arg2}) do Logger.info(&quot;Got second arg: \#{arg2}&quot;) end @impl QWIT.Step def step_back(%{} = _args) do Logger.info(&quot;Something went horribly wrong...&quot;) end endFor especially complex workflows, you can call sub-Flows as though they were Steps - QWIT handles the differences transparently behind the scenes.defmodule MyApp.Work.Flows.Example2 do use QWIT.Flow @impl QWIT.Flow def build_flow do step MyApp.Work.Flows.Example, %{arg3: &quot;value3&quot;} # arg3 is available to all steps in sub-Flow step MyApp.Work.Steps.Example end endObanOban is the default backend, so you don't have to do anything special to use it. However, if you prefer to be explicit, you can pass backend: QWIT.Oban to your use statements: use QWIT.Flow, backend: QWIT.Oban use QWIT.Step, backend: QWIT.ObanCustom EnginesDon't see your engine listed here? That's fine - you can write your own! PRs are also happily accepted. Have a look at the flow.ex and step.ex in lib/qwit/oban for a good example of how this looks, and how simple it is to build your own. Don't forget to tell QWIT where to look for your backend! use QWIT.Flow, backend: MyBackend use QWIT.Step, backend: MyBackend","ref":"readme.html#usage","title":"Queued Workflows In Transactions - Usage","type":"extras"},{"doc":"To submit feedback, please use the project's GitHub Issues. Unless the feedback is a security issue; in that case, email Dan directly.","ref":"readme.html#feedback","title":"Queued Workflows In Transactions - Feedback","type":"extras"}]